<?php

/*----------------------------------------

$Id: util.php,v 1.63.2.1 2005/01/31 21:49:52 mfrumin Exp $

vim: ts=4 foldcolumn=4 foldmethod=marker



This file is part of Reblog: http://reblog.org

A derivative work of Feed On Feeds: http://feedonfeeds.com



Distributed under the Gnu Public License, see LICENSE



Copyright 2004 Michael Frumin, Michal Migurski

mike@stamen.com, http://stamen.com

mfrumin@eyebeam.org, http://eyebeam.org



util.php - utility functions used from other scripts

----------------------------------------*/



    function ref_do_query($q, $params = null, $live = 0)

    {

        global $REF_DBH;

        

        $res = $REF_DBH->query($q, $params);

        

        if (DB::isError($res)) {

            $err = $res->getMessage() . ":" . $res->getDebugInfo();

            if($live) {

                print "<B>MYSQL ERROR: $err</B><BR>\n";

                return 0;

            } else{

                die($err);

            }

        }

        

        return $res;

    }



    function ref_can_boolean_search() 

    {

      global $REF_DBH;

      

      $test_q = sprintf('SELECT * FROM %s it WHERE

                         id = 1 AND

                         MATCH (it.title, it.link, it.content, it.dccreator, it.dcsubject) AGAINST (\'test\' IN BOOLEAN MODE)'

			,

			REF_ITEM_TABLE

			);



      $res = $REF_DBH->query($test_q);

      

      if (DB::isError($res)) {

	return false;

      }

      else {

	return true;

      }

    }





    function ref_is_subscribed($url)

    {

        return 0; // not checked for isparsed condition.

		//return RF_Feed::_retrieve(array('where' => array( 'url' => $url)));

    }







// CDATAFY

    function ref_cdata_escape($s)

    {

        return str_replace("]]>", " ] ] >", $s);

    }



// ARRAYIFYING





// HELPER

    

    function ref_find_links($content) 

    {

        $n = preg_match_all("/<a [^\>]*href\=[\'\"]*([^\"\'\s]+)[\'\"]*[^\>]*\>/i", $content, $matches, PREG_SET_ORDER);

        

        $res = array();

        

        foreach($matches as $m) {

            $res[] = $m[1];

        }

        

        return $res;

    }





// DATE/TIME CONVERSIONS

    function ref_unix_timestamp2iso8601($ts)

    {

        return date("Y-m-d H:i:s O",$ts);

    }



    function ref_unix_timestamp2rfc822($ts)

    {

        return date("r",$ts);

    }



    function ref_rfc8222unix_timestamp($rfc822)

    {

        return strtotime($rfc822);

    }



    function ref_iso86012unix_timestamp($iso8601)

    {

        return parse_w3cdtf($iso8601) - (REF_TIME_OFFSET * 60 * 60);

    }





    function ref_sql_timestamp2unix_timestamp($ts)

    {

      // just a pass thru because now always use UNIX_TIMESTAMP(timestamp) in the SQL

      return $ts;

    }



    function ref_sql_timestamp2iso8601($ts)

    {

        return (unix_timestamp2iso8601(sql_timestamp2unix_timestamp($ts)));

    }

// FOR LOADING FEEDS WITH STATS, FOR VIEW PAGE



    function ref_load_feeds($args)

    {

        $feedSelects = RF_FeedSelect::_retrieve_all(array('order' => array('ft.title' => 'ASC')));

        

        $feedHash = array();

        $ids = array();

        for($i = 0; $i < count($feedSelects); $i++) {	

            $feedHash[$feedSelects[$i]->feed_id] = &$feedSelects[$i];;

            $ids[] = $feedSelects[$i]->feed_id;

        }

        

        $feeds = (count($ids) == 0 ? array() : RF_Feed::_retrieve_all(array( 'where' =>array('id' =>array("in", "(" . join(",", $ids) . ")")))));



        for($i = 0; $i < count($feeds); $i++) {

            $feedHash[$feeds[$i]->id]->feed($feeds[$i]);

        }

        

        $stats = (count($ids) == 0 ? array() : RF_FeedStats::_retrieve_all(array( 

										 'where' => array('id' => array("in", "(" . join(",", $ids) . ")")) ,

										 '_filter' => array( 'search' => $args['search'])

										 

										 )

									   )

		  );



        

        for($i = 0; $i < count($stats); $i++) {

            $feedHash[$stats[$i]->id]->stats($stats[$i]);

        }

        

        if($_SESSION['feed_sort'] == 'age')

            usort($feedSelects, create_function('$a, $b', 'return $a->stats->age - $b->stats->age;'));



        if($_SESSION['feed_sort'] == 'items')

            usort($feedSelects, create_function('$a, $b', 'return $b->stats->unread - $a->stats->unread;'));



        return $feedSelects;

    }

    



// FOR LOADING ITEMS, PARAMETERIZED

    

    function ref_load_items($sql)

    {

        $itemSelects = RF_ItemSelect::_retrieve_all($sql);

        

        $itemHash = array();

        $feedHash = array();

        

        for($i = 0; $i < count($itemSelects); $i++) {

            $item_id = $itemSelects[$i]->item_id;

            $feed_id = $itemSelects[$i]->feed_id;

            $itemHash[$item_id] = &$itemSelects[$i];

            if(!isset($feedHash[$feed_id])) {

                $feedHash[$feed_id] = array();

            }

            $feedHash[$feed_id][] = &$itemSelects[$i];

        }

        

        $feed_ids = array_keys($feedHash);

        $item_ids = array_keys($itemHash);

        

        $feeds = (count($feed_ids) == 0 ? array() : RF_Feed::_retrieve_all(array( 'where' =>array('id' =>array("in", "(" . join(",", $feed_ids) . ")")))));

        

        for($i = 0; $i < count($feeds); $i++) {

            $feed_id = $feeds[$i]->id;

            for($j = 0; $j < count($feedHash[$feed_id]); $j++) {

                $feedHash[$feed_id][$j]->feed($feeds[$i]);

            }

        }

        

        $items = (count($item_ids) == 0 ? array() : RF_Item::_retrieve_all(array( 'where' =>array('id' =>array("in", "(" . join(",", $item_ids) . ")")))));

        

        for($i = 0; $i < count($items); $i++) {

            $itemHash[$items[$i]->id]->item($items[$i]);

        }

        

        return $itemSelects;

    }

    

    

/************** RSS UTILITY STUFF ****************/



    function ref_opml_to_array($opml)

    {

        $rx = "/xmlurl=\"(.*?)\"/mi";

        

        if(preg_match_all($rx, $opml, $m)) {

            for($i = 0; $i < count($m[0]) ; $i++) {

                $r[] = $m[1][$i];

            }

        }

        

        return $r;

    }





    function ref_getRSSLocation($html, $location)

    {

        if(!$html or !$location) {

            return false;

        } else {

            #search through the HTML, save all <link> tags

            # and store each links attributes in an associative array

            preg_match_all('/<link\s+(.*?)\s*\/?'.'>/si', $html, $matches);

            $links = $matches[1];

            $final_links = array();

            $link_count = count($links);

            for($n=0; $n<$link_count; $n++) {

                $attributes = preg_split('/\s+/s', $links[$n]);

                foreach($attributes as $attribute) {

                    $att = preg_split('/\s*=\s*/s', $attribute, 2);

                    if(isset($att[1])) {

                        $att[1] = preg_replace('/([\'"]?)(.*)\1/', '$2', $att[1]);

                        $final_link[strtolower($att[0])] = $att[1];

                    }

                }

                $final_links[$n] = $final_link;

            }

            #now figure out which one points to the RSS file

            for($n=0; $n<$link_count; $n++) {

                if(strtolower($final_links[$n]['rel']) == 'alternate') {

                    if(strtolower($final_links[$n]['type']) == 'application/rss+xml') {

                        $href = $final_links[$n]['href'];

                    }

                    if(!$href and strtolower($final_links[$n]['type']) == 'text/xml') {

                        #kludge to make the first version of this still work

                        $href = $final_links[$n]['href'];

                    }

                    if($href) {

                        if(strstr($href, "http://") !== false) { #if its absolute

                            $full_url = $href;

                        } else { #otherwise, 'absolutize' it

                            $url_parts = parse_url($location);

                            #only made it work for http:// links. Any problem with this?

                            $full_url = "http://$url_parts[host]";

                            if(isset($url_parts['port'])) {

                                $full_url .= ":$url_parts[port]";

                            }

                            if($href {0} != '/') { #its a relative link on the domain

                                $full_url .= dirname($url_parts['path']);

                                if(substr($full_url, -1) != '/') {

                                    #if the last character isnt a '/', add it

                                    $full_url .= '/';

                                }

                            }

                            $full_url .= $href;

                        }

                        return $full_url;

                    }

                }

            }

            return false;

        }

    }







function merge_hash($h1, $h2) {



  $res = $h1;



  foreach($h2 as $k => $v) {

    $res[$k] = $v;

  }



  return $res;

}



?>

